Lua_FightInfoItem = class("Lua_FightInfoItem", Lua_DisplayObject)
function Lua_FightInfoItem:ctor(p)
	self:superCall("ctor", p, "FightInfoItem_skin")
end

function Lua_FightInfoItem:buildShowItem()
	self:superCall("buildShowItem")

	self.leftForce = Lua_NumberImage.new(self.content)
	self.leftForce:setLocation(-240, -30, 0)
	self.leftForce.pivot = 1
	self.leftForce.numOffsetX = -4
	self.leftForce.numAtlas = "number"
	self.leftForce.preStr = "xui_zl1_number_0"

	self.rightForce = Lua_NumberImage.new(self.content)
	self.rightForce:setLocation(275.8, -30, 0)
	self.rightForce.pivot = -1
	self.rightForce.numOffsetX = -4
	self.rightForce.numAtlas = "number"
	self.rightForce.preStr = "xui_zl1_number_0"

	-- self.leftAureole:addClickFuntion(self, self.onLeftAureole)
	-- self.rightAureole:addClickFuntion(self, self.onRightAureole)
	self.connIcon_1:addClickFuntion(self, self.checkAttackerConn);
	self.connIcon_2:addClickFuntion(self, self.checkDefenderConn);
end

function Lua_FightInfoItem:dispose()
	if self.leftForce then
		self.leftForce:dispose()
		self.leftForce = nil
	end
	if self.rightForce then
		self.rightForce:dispose()
		self.rightForce = nil
	end
	self.recordVo = nil
	self:superCall("dispose")
end

function Lua_FightInfoItem:setName(leftName, rightName)
	self.leftName.text = leftName
	self.rightName.text = rightName
end

function Lua_FightInfoItem:setData(recordVo)
	self.recordVo = recordVo

	self.connIcon_1:setAltas("hero_embattle", "xui_bz_widget_"..24 + recordVo.attackerConnNum)
	self.connCount_1.text = recordVo.attackerConnNum

    self.connIcon_2:setAltas("hero_embattle", "xui_bz_widget_"..24 + recordVo.defenderConnNum)
   	self.connCount_2.text = recordVo.defenderConnNum
end

function Lua_FightInfoItem:setForce(leftForce, rightForce)
	if leftForce and leftForce > 0 then
		self.leftForce.num = leftForce
		self.leftIcon:setEnable(true)
	else
		self.leftForce.num = nil
		self.leftIcon:setEnable(false)
	end
	if rightForce and rightForce > 0 then
		self.rightForce.num = rightForce
		self.rightIcon:setEnable(true)
		self.rightIcon:setLocation(275.8 - self.rightForce.totalWidth - 20, -30, 0)
	else
		self.rightForce.num = nil
		self.rightIcon:setEnable(false)
	end
end

function Lua_FightInfoItem:checkAttackerConn(go)
	if self.recordVo == nil or self.recordVo.attackerConnArr == nil or self.recordVo.attackerConnArr:getSize() <= 0 then
		OperateAlert.showLangValue(126066)
		return
	end
	Lua_WindowUtil.openWin("Lua_HeroConnectListWindow", Lua_WinParam.ACTION_OPEN, self.recordVo.attackerConnArr)
end

function Lua_FightInfoItem:checkDefenderConn(go)
	if self.recordVo == nil or self.recordVo.defenderConnArr == nil or self.recordVo.defenderConnArr:getSize() <= 0 then
		OperateAlert.showLangValue(126066)
		return
	end
	Lua_WindowUtil.openWin("Lua_HeroConnectListWindow", Lua_WinParam.ACTION_OPEN, self.recordVo.defenderConnArr)
end