-- 战斗
checkRequire("Lua_FightInfoItem")
checkRequire("Lua_FightIntoEffShowPanel"); -- 开始特效
checkRequire("Lua_FightBossHurtPanel"); -- BOSS伤害
checkRequire("Lua_FightBossChallengeHurtPanel"); -- BOSS挑战伤害
checkRequire("Lua_FightStarPanel"); -- 战斗星级
checkRequire("Lua_FightGradePanel"); -- 战斗评级
checkRequire("Lua_FightTeamUpPanel"); -- 战斗组队
checkRequire("Lua_FightDetachmentPanel"); -- 战斗分队
-- checkRequire("Lua_FightTurnOnPromptsItem") -- 开启提示
checkRequire("Lua_KunXuHolyLandStartFightPanel") -- 昆墟圣地开始界面
checkRequire("Lua_FightArtifactPanel") -- 神器释放技能
checkRequire("Lua_FightBossInfoPanel") -- BOSS信息
checkRequire("Lua_FightPlotPanel") -- 剧情
Lua_FightMainWindow = class("Lua_FightMainWindow", Lua_Window);
function Lua_FightMainWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_FightMainWindow";
	self.skinName = "FightMainWindow_skin";
	self.isFullSizeWin = true;
	self.isSingleShowWin = true;
end

function Lua_FightMainWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("FIGHTPLAY_ROTATION_CHANGE", self, self.showStartEff);
	self:addLuaEvent("fight_formation_change", self, self.onFormationChange);
	self:addLuaEvent("fightPlay_speed_change", self, self.onSpeedChange);
	self:addLuaEvent("fight_enter_scene", self, self.onUpdateRecordInfo);
	self:addLuaEvent("fight_execute_action", self, self.onUpdateExecuteActionInfo);
	self:addLuaEvent("skillAttackHurtUpdate", self, self.onSkillHurtUpdate);
	self:addLuaEvent("fight_roleSkill_update", self, self.onUpdateRoleSkill);
	self:addLuaEvent("FIGHTPLAY_CHECK_UPDATE", self, self.onUpdateCheck);
	self:addLuaEvent("fight_plotEvent_update", self, self.onServerPlotUpdate);
	self:addLuaEvent("FIGHT_BOSS_INFO_UPDATE", self, self.onUpdateBossInfo);
end

function Lua_FightMainWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.curAction = 1; -- 当前行动
	self.curRound = 1; -- 当前回合
	self.curRotation = 1; -- 当前轮次

	self:createGradePanel();
	self:createTeamUpPanel();

	self.rotationObj:SetActive(false);
	self.roundObj:SetActive(false);
	self.hurtObj:SetActive(false);
	self.skillObj_1:SetActive(false);
	self.skillObj_2:SetActive(false);

	LuaUtil.setObjPos(self.maskObj, 0, GlobalVar.screenOffsetTopH, 0);
	self.maskObj:SetActive(false);
	self.pauseMask:SetDimensions(self.width, MainWinDefine.V_height);
	self.pauseMask:addClickFuntion(self, self.onBlackMaskClick);

	self.infoItem = Lua_FightInfoItem.new(self.showObject)
	self.infoItem:setRectAnchor(1)
	self.infoItem:setLocation(0, -39, 0)

	-- 关闭布阵界面
	Lua_WindowUtil.openWin("Lua_FightLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_InfinityHallIndividualWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_InfinityHallTeamWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_TowerLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_StarTrialLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_NewHeroActStoryLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_PeakDuelMatchWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_EquipCopyLineupWindow", Lua_WinParam.ACTION_CLOSE);	--关闭寂灭岛布阵界面
	Lua_WindowUtil.openWin("Lua_TeamSaloonWindow", Lua_WinParam.ACTION_CLOSE); -- 关闭寂灭岛组队界面
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandLineupWindow", Lua_WinParam.ACTION_CLOSE); -- 关闭昆墟圣地布阵界面
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandEmbattleWindow", Lua_WinParam.ACTION_CLOSE); -- 关闭昆墟圣地战斗阵容准备界面
	Lua_WindowUtil.openWin("Lua_LeagueDuelLineupWindow", Lua_WinParam.ACTION_CLOSE); -- 关闭公会对抗抢夺布阵界面
	Lua_WindowUtil.openWin("Lua_BossChallengeLineupWindow", Lua_WinParam.ACTION_CLOSE); -- BOSS挑战布阵界面
end

function Lua_FightMainWindow:dispose()
	if self.roundNumTxt then
		TweenUtil.getInstance():stop(self.roundNumTxt.mainContent);
	end
	if self.skillObj_1 then
		TweenUtil.getInstance():stop(self.skillObj_1);
	end
	if self.skillObj_2 then
		TweenUtil.getInstance():stop(self.skillObj_2);
	end
	if self.hurtObj then
		TweenUtil.getInstance():stop(self.hurtObj);
	end
	
	Lua_CommonUtil.removeTimer(self, self.hideskillObj1);
	Lua_CommonUtil.removeTimer(self, self.hideskillObj2);
	Lua_CommonUtil.removeTimer(self, self.onOverStartEffShow);
	Lua_CommonUtil.removeTimer(self, self.onOverSkillHurtShow);

	-- Lua_WindowUtil.openWin("Lua_HeroLineupAureoleWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	Lua_WindowUtil.openWin("Lua_HeroConnectListWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	Lua_WindowUtil.openWin("Lua_InfinityHallBuffWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	Lua_WindowUtil.openWin("Lua_FightOverallBuffWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	Lua_WindowUtil.openWin("Lua_FightBuffDetailsWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	Lua_WindowUtil.openWin("Lua_FightQueueWindow", Lua_WinParam.ACTION_CLOSE, nil, true);

	if self.startEffPanel ~= nil then -- 移除开始动画
		self.startEffPanel:dispose();
		self.startEffPanel = nil;
	end

	if self.infoItem then
		self.infoItem:dispose()
		self.infoItem = nil
	end

	if self.artifactPanel then
		self.artifactPanel:dispose()
		self.artifactPanel = nil
	end

	self:clearPanel()
	if self.operateList then
		self.operateList:dispose()
		self.operateList:clear()
		self.operateList = nil
	end

	if self.speedTips then
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOperate("fight_speed_tips", 1)
		self.speedTips:dispose()
		self.speedTips = nil

		self.speedEff:dispose();
		self.speedEff = nil;
	end
	if self.hangTips then
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOperate("fight_hang_tips", 1)
		self.hangTips:dispose()
		self.hangTips = nil

		self.hangEff:dispose();
		self.hangEff = nil;
	end

	if self.bossInfoPanel then
		self.bossInfoPanel:dispose()
		self.bossInfoPanel = nil
	end

	self._recordVo = nil;
	self:updateFightPlot(0);
	self:superCall("dispose");
end

function Lua_FightMainWindow:onScreenResize()
	self:superCall("onScreenResize");
	LuaUtil.setObjPos(self.maskObj, 0, GlobalVar.screenOffsetTopH, 0);
	self.pauseMask:SetDimensions(self.width, MainWinDefine.V_height);
end

function Lua_FightMainWindow:showWin(param)
	self:superCall("showWin", param);
	print("curShowFight : ", param)

	-- 重播数据下发后，移除旧ID
	local removeFightId = DataCenter.fightData.removeFightId
	if removeFightId and param ~= removeFightId then
		DataCenter.fightData:removeFight(removeFightId, false)
		DataCenter.fightData.removeFightId = nil
	end

	self:init()

	local recordVo = DataCenter.fightData:getRecordVoById(param);

	-- 结算界面直接挑战下一层/下一关，关闭结算界面
	local config = Lua_FightTemplateConfigData.getConfigData(recordVo.templateId)
	if config.sys_type == Lua_FightDefine.FIGHT_TYPE_MAINLINE then
		Lua_WindowUtil.openWin("Lua_MainLineFightWinWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	elseif recordVo.templateId == 1004 or recordVo.templateId == 1007 or recordVo.templateId == 1008 or recordVo.templateId == 1009 or recordVo.templateId == 1010 then
		Lua_WindowUtil.openWin("Lua_ClimbTowerFightWinWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	end

	self:updateFightPlot(0);
	self:onUpdateRecordInfo(param);
	self:showStartEff(1);
end

function Lua_FightMainWindow:init()
	-- 防止多次点击跳过按钮、挂起按钮
	self.isPressSkip = nil;
	self.isPressHang = nil;

	TweenUtil.getInstance():stop(self.roundNumTxt.mainContent);
	TweenUtil.getInstance():stop(self.skillObj_1);
	self.skillObj_1:SetActive(false);
	TweenUtil.getInstance():stop(self.skillObj_2);
	self.skillObj_2:SetActive(false);
	TweenUtil.getInstance():stop(self.hurtObj);
	self.hurtObj:SetActive(false);
	Lua_CommonUtil.removeTimer(self, self.hideskillObj1);
	Lua_CommonUtil.removeTimer(self, self.hideskillObj2);
	Lua_CommonUtil.removeTimer(self, self.onOverSkillHurtShow);

	if self.bossInfoPanel then
		self.bossInfoPanel:setEnable(false)
	end
end

function Lua_FightMainWindow:onUpdateRecordInfo(rid)
	if self._recordId ~= rid then
		self._recordId = rid;
		self._recordVo = DataCenter.fightData:getRecordVoById(rid);
		if self._recordVo == nil then
			return;
		end
		self._maxRotation = self._recordVo.maxRotation;
		self._maxRound = self._recordVo.maxRound;

		if self.templateId ~= self._recordVo.templateId then
			self:clearPanel()
		end
		self.templateId = self._recordVo.templateId
		self:createPanel()
		self:checkOperate()

		self:onSkillHurtUpdate(0)
		self:updateRoleInfo();
		local player = DataCenter.fightData:getFightPlayerById(self._recordId);
		if player ~= nil then
			self.curSession = player.curSession;
			self.curRotation = player.curRotation;
			self.curRound = player.curRound;
			self.curAction = player.curAction;
			self:onFormationChange();
			self:onUpdateRoleSkill();
			self:onUpdateExecuteActionInfo(player.curPlayActionInfo);
			if self._recordVo.bPlayedStartEff == true and self.startEffPanel ~= nil then
				self:updateFightPlot(self._recordVo.plotId);
			end
		end
	end
end

function Lua_FightMainWindow:updateRoleInfo()
	self.infoItem:setName(self._recordVo.attacker.name, self._recordVo.defender.name)
	local attackerForce = 0
	local defenderForce = 0
	local lineup = self._recordVo.attackerLineup
	if lineup then
		attackerForce = lineup.force
	end
	lineup = self._recordVo.defenderLineup
	if lineup then
		defenderForce = lineup.force
	end
	self.infoItem:setForce(attackerForce, defenderForce)
end

function Lua_FightMainWindow:onFormationChange()
	self.infoItem:setData(self._recordVo)
end

function Lua_FightMainWindow:onUpdateExecuteActionInfo(info)
	if self.fightPlotPanel ~= nil then
		self.fightPlotPanel:frameScript();
		local player = DataCenter.fightData:getFightPlayerById(self._recordId);
		if player.bStopPlay then
			return;
		end
	end

	if info == nil then
		return;
	end

	local bRoundChange = (info.round > self.curRound);
	self.curSession = info.session;
	self.curRotation = info.rotation;
	self.curRound = info.round;

	if self._maxRotation > 0 then
		self.rotationTxt.text = LanUtil.formateStr(302009, tostring(self.curRotation), tostring(self._maxRotation));
	else
		self.rotationTxt.text = LanUtil.formateStr(302000, tostring(self.curRotation));
	end

	local str
	if info.round > 9 then
		str = "   "
	else
		str = "  "
	end
	if self._maxRound > 0 then
		self.roundTxt.text = LanUtil.formateStr(302001, str, tostring(self._maxRound));
		if self._maxRound > 9 then
			self.roundNumTxt:setLocation(-30, -60, 0)
		else
			self.roundNumTxt:setLocation(-22, -60, 0)
		end
	else
		self.roundTxt.text = LanUtil.formateStr(302002, str);
	end
	self.roundNumTxt.text = self.curRound;

	if bRoundChange then
		TweenUtil.getInstance():stop(self.roundNumTxt.mainContent);
		TweenUtil.getInstance():addTweenTargetScale(self.roundNumTxt.mainContent, 0.2, 0, 1.5, 1.5, 1.5);
		TweenUtil.getInstance():addTweenTargetScale(self.roundNumTxt.mainContent, 0.2, 0.2, 1, 1, 1);
		self:onUpdateRoleSkill()
	end

	if self.gradePanel ~= nil then
		self.gradePanel:setData(self._recordId, self._recordVo.teamId);
	end

	if self.teamUpPanel ~= nil then
		self.teamUpPanel:setData(self._recordId, self._recordVo.teamId);
	end
	
	if info.type == 2 then -- 释放技能
		local skillId = info.skill_id; -- 技能id
		local fighterId = tonumber(tostring(info.fighter_id));
		local skillCfg = Lua_SkillConfigData.getConfigData(skillId);
		local thing = DataCenter.thingData:getThingPlayer(self._recordVo.sceneId, self._recordId, fighterId);
		if skillCfg ~= nil and thing ~= nil then
			local kind = thing.player.data.kind;
			local formationType = thing.formationType;
			if kind == Lua_ThingDefine.PLAYER then
				self.skillObj_2:SetActive(false);
				self.skillObj_1:SetActive(true);
				self.skill_name_1.text = skillCfg.name;
				if skillCfg.artifactId > 0 then
					self.skill_icon_1:setEnable(true)
					local vo = DataCenter.artifactUtil:getArtifactVoById(skillCfg.artifactId)
					self.skill_icon_1:setUrl(vo.icon_2)
				else
					self.skill_icon_1:setEnable(false)
				end
				TweenUtil.getInstance():stop(self.skillObj_1);
				if formationType == Lua_FightDefine.FIGHT_ATTACKER then
					self.skill_bg_1:setScale(1, 1, 1);
					self.skill_icon_1:setLocation(-21, 60, 0);
					self.skill_icon_1:setScale(1, 1, 1);
					self.skill_icon_2:setLocation(-146.5, 29, 0);
					self.skill_icon_2:setScale(1, 1, 1);
					self.skill_name_1:setLocation(223, -55.5, 0);

					self.skillHideX1 = 720;
					LuaUtil.setObjPos(self.skillObj_1, -720, -33, 0);
					TweenUtil.getInstance():addTweenTargetPos(self.skillObj_1, 0.3 / self._recordVo.speed, 0, 0, -33, 0, 0, false);
				else
					self.skill_bg_1:setScale(-1, 1, 1);
					self.skill_icon_1:setLocation(21, 60, 0);
					self.skill_icon_1:setScale(-1, 1, 1);
					self.skill_icon_2:setLocation(146.5, 29, 0);
					self.skill_icon_2:setScale(-1, 1, 1);
					self.skill_name_1:setLocation(-223, -55.5, 0);

					self.skillHideX1 = -720;
					LuaUtil.setObjPos(self.skillObj_1, 720, -33, 0);
					TweenUtil.getInstance():addTweenTargetPos(self.skillObj_1, 0.3 / self._recordVo.speed, 0, 0, -33, 0, 0, false);
				end
				Lua_CommonUtil.delayCall(1 / self._recordVo.speed, self, self.hideskillObj1);
			else
				self.skillObj_1:SetActive(false);
				if skillCfg.skillType == 3 or skillCfg.skillType == 4 then
					self.skillObj_2:SetActive(true);
					self.skill_name_2.text = skillCfg.name;

					local md;
					local atlasName = nil;
					local spriteName = nil;
					if kind == Lua_ThingDefine.MONSTER then
				        md = Lua_MonsterConfigData.getMonsterConfig(thing.objId);
				    elseif kind == Lua_ThingDefine.HERO then
				        md = Lua_HeroConfigData.getConfig(thing.objId);
				    end

				    if md ~= nil then
						atlasName = md.avatar_atlas_2;
						spriteName = md.avatar_sprite_2;
					end
					self.heroAvatar:setAltas(atlasName, spriteName);
					self.heroAvatar:resetSize();
					
					TweenUtil.getInstance():stop(self.skillObj_2);
					if formationType == Lua_FightDefine.FIGHT_ATTACKER then
						self.skill_bg_2:setScale(1, 1, 1);
						self.heroAvatar:setScale(1, 1, 1);
						self.skill_name_2.pivotValue = 3;
						self.skill_name_2:setLocation(140, -1, 0);
						self.skill_name_2.alignmentValue = 3;

						self.skillHideX2 = -1080;
						self.skillHideY = 108;
						LuaUtil.setObjPos(self.skillObj_2, -1080, 108, 0);
						TweenUtil.getInstance():addTweenTargetPos(self.skillObj_2, 0.3 / self._recordVo.speed, 0, -360, 108, 0, 0, false);
					else
						self.skill_bg_2:setScale(-1, 1, 1);
						self.heroAvatar:setScale(-1, 1, 1);
						self.skill_name_2.pivotValue = 5;
						self.skill_name_2:setLocation(-140, -1, 0);
						self.skill_name_2.alignmentValue = 5;
						self.skillHideX2 = 1080;
						self.skillHideY = 225;
						LuaUtil.setObjPos(self.skillObj_2, 1080, 225, 0);
						TweenUtil.getInstance():addTweenTargetPos(self.skillObj_2, 0.3 / self._recordVo.speed, 0, 360, 225, 0, 0, false);
					end
					Lua_CommonUtil.delayCall(1 / self._recordVo.speed, self, self.hideskillObj2);
				end
			end
		end 
	end
end

function Lua_FightMainWindow:hideskillObj1()
	TweenUtil.getInstance():stop(self.skillObj_1);
	Lua_CommonUtil.removeTimer(self, self.hideskillObj1);
	TweenUtil.getInstance():addTweenTargetPos(self.skillObj_1, 0.3 / self._recordVo.speed, 0, self.skillHideX1, -33, 0, 0, false);
end

function Lua_FightMainWindow:hideskillObj2()
	TweenUtil.getInstance():stop(self.skillObj_2);
	Lua_CommonUtil.removeTimer(self, self.hideskillObj2);
	TweenUtil.getInstance():addTweenTargetPos(self.skillObj_2, 0.3 / self._recordVo.speed, 0, self.skillHideX2, self.skillHideY, 0, 0, false);
end

function Lua_FightMainWindow:showStartEff(index)
	local exitTime = 0;
	if index == 1 then
		if self._recordVo.bPlayedStartEff ~= true then
			self._recordVo.bPlayedStartEff = true;
			if self.startEffPanel == nil then
				if self.templateId == Lua_FightDefine.TEMPLATE_ID_KUNXU then
					self.startEffPanel = Lua_KunXuHolyLandStartFightPanel.new(self.content);
				else
					self.startEffPanel = Lua_FightIntoEffShowPanel.new(self.content);
					self.startEffPanel:setStart();
				end
			end
			exitTime = self.templateId == Lua_FightDefine.TEMPLATE_ID_KUNXU and DataCenter.kunXuHolyLandUtil.startFightTime or DataCenter.fightUtil.startEffectTime;
		end
	else
		if self.startEffPanel ~= nil then
			self.startEffPanel:dispose();
			self.startEffPanel = nil;
		end

		self:updateRoleInfo();
		self.startEffPanel = Lua_FightIntoEffShowPanel.new(self.content);
		self.startEffPanel:setLocation(0, GlobalVar.screenOffsetTopH, 0);
		self.startEffPanel:setIndex(index);
		exitTime = DataCenter.fightUtil.startEffectTime;
	end
	if exitTime > 0 then
		if self.artifactPanel then
			self.artifactPanel:setEnable(false)
		end
		Lua_CommonUtil.removeTimer(self, self.onOverStartEffShow);
		Lua_CommonUtil.delayCall(exitTime / self._recordVo.speedRate, self, self.onOverStartEffShow);
	end
end

function Lua_FightMainWindow:onOverStartEffShow()
	self.isPressSkip = nil;
	if self.startEffPanel ~= nil then
		self.startEffPanel:dispose();
		self.startEffPanel = nil;
	end
	self:onUpdateRoleSkill();
	self:updateFightPlot(self._recordVo.plotId);
end

function Lua_FightMainWindow:onSkillHurtUpdate(hurtVal)
	Lua_CommonUtil.removeTimer(self, self.onOverSkillHurtShow);

	local player = DataCenter.fightData:getFightPlayerById(self._recordId);
	if player == nil or player.bRunBack == true then
		self.hurtObj:SetActive(false);
		return;
	end

	local info = player.curPlayActionInfo;
	if info == nil or info.type ~= 2 then -- 非技能
		self.hurtObj:SetActive(false);
		return;
	end

	if hurtVal > 0 then
		if not self.hurtObj.activeSelf then
			self.hurtObj:SetActive(true);
			LuaUtil.setObjScale(self.hurtObj, 2, 2, 2)
			TweenUtil.getInstance():stop(self.hurtObj)
			TweenUtil.getInstance():addTweenTargetScale(self.hurtObj, 0.1, 0, 1, 1, 1)
		end
		
		if self.hurtNum == nil then
			self.hurtNum = Lua_NumberImage.new(self.hurtObj);
			self.hurtNum:setLocation(-120, -18, 0);
			self.hurtNum.pivot = 1;
			self.hurtNum.numOffsetX = -12;
			self.hurtNum.numAtlas = "number"
			self.hurtNum.preStr = "xui_zd_number_";
		end
		self.hurtNum.num = hurtVal;
		
		Lua_CommonUtil.delayCall(DataCenter.fightUtil.skillHurtWaitTime, self, self.onOverSkillHurtShow);
	else
		self.hurtObj:SetActive(false);
	end
end

function Lua_FightMainWindow:onOverSkillHurtShow()
	self.hurtObj:SetActive(false);
end

function Lua_FightMainWindow:onUpdateRoleSkill()
	if self.startEffPanel ~= nil then
		if self.artifactPanel then
			self.artifactPanel:setEnable(false)
		end
		return;
	end

	-- 不播放开场动画则更新主角技能
	if self._recordVo ~= nil and self._recordVo.bPlayedStartEff ~= true then
		if self.artifactPanel then
			self.artifactPanel:setEnable(false)
		end
		return;
	end

	local player = DataCenter.fightData:getFightPlayerById(self._recordId);
	if player == nil then
		if self.artifactPanel then
			self.artifactPanel:setEnable(false)
		end
		return;
	end

	local num = table.length(player.artifactSkillDic)
	if num <= 0 then
		if self.artifactPanel then
			self.artifactPanel:setEnable(false)
		end
		return;
	end

	if self.artifactPanel == nil then
		self.artifactPanel = Lua_FightArtifactPanel.new(self.content)
		self.artifactPanel:setSiblingIndex(0)
		self.artifactPanel:setRectAnchor(9)
	end
	self.artifactPanel:setEnable(true)
	self.artifactPanel:setData(player)
end

function Lua_FightMainWindow:checkOperate()
	self.roundObj:SetActive(true)
	
	local list;
	if self._recordVo.isReplay == true then
		if self._recordVo.flag == Lua_FightDefine.REPLAY_VIDEO then
			list = self._recordVo.templateConfig.video_show;
		else
			list = self._recordVo.templateConfig.replay_show;
		end
	else
		list = self._recordVo.templateConfig.normal_show;
	end
	if list == nil then
		return;
	end

	local arr = Array(); -- 右下角操作按钮
	local _arr = Array(); -- 暂停操作选项按钮
	local len = #list
	for i = 1, len do
		if list[i] == 3 then -- 暂停
			if DataCenter.funcOpenData:isOpened(self._recordVo.templateConfig.pauseCond) then
				arr:add(list[i]);
			end
		elseif list[i] == 5 then -- 显示波数
			self.rotationObj:SetActive(true);
		elseif list[i] == 6 then -- 分队信息
			local lineup = self._recordVo.attacker.lineup;
			if lineup ~= nil and lineup[2] ~= nil then
				arr:add(list[i]);
			end
		elseif list[i] == 11 then -- 放弃战斗
			_arr:add(list[i]);
		elseif list[i] == 12 then -- 重新开始
			_arr:add(list[i]);
		else
			arr:add(list[i]);
		end
	end
	_arr:add(13); -- 继续

	if self.operateList == nil then
		self.operateList = Array()
	end
	len = self.operateList:getSize()
	for i = 1, len do
		self.operateList[i]:setEnable(false)
	end

	self.speedIcon = nil
	len = arr:getSize()
	local index = 1
	local posY
	local icon
	while len > 0 do
		icon = self.operateList[index]
		if icon == nil then
			icon = UICreate.createUIAtlasImage(self.showObject, nil, nil, 0, 0, 0, 0)
			self.operateList:add(icon)
		else
			icon:setEnable(true)
		end
		icon.anchorValue = 7
		posY = 55 + (index - 1) * 102
		if arr[len] == 0 then -- 加速
			icon:setAltas("fight_atlas_1", "xui_zd_button_01"..(self._recordVo.showSpeed + 3).."_n")
			self.speedIcon = icon
			self:createSpeedTips(posY)
		elseif arr[len] == 1 then -- 跳过
			icon:setAltas("fight_atlas_1", "xui_zd_button_021_n")
		elseif arr[len] == 2 then -- BUFF
			icon:setAltas("fight_atlas_1", "xui_zd_button_019_n")
		elseif arr[len] == 3 then -- 暂停
			icon:setAltas("fight_atlas_1", "xui_zd_button_018_n")
		elseif arr[len] == 4 then -- 挂起
			icon:setAltas("fight_atlas_1", "xui_zd_button_020_n")
			self:createHangTips(posY)
		elseif arr[len] == 6 then -- 分队信息
			icon:setAltas("fight_atlas_1", "xui_zd_button_019_n")
		end
		icon.name = arr[len]
		icon:setLocation(302, posY, 0)
		icon:addClickFuntion(self, self.onButtonClick)

		index = index + 1
		len = len - 1
	end

	if self.giveUpIcon then self.giveUpIcon:setEnable(false) end
	if self.replayIcon then self.replayIcon:setEnable(false) end
	if self.continueIcon then self.continueIcon:setEnable(false) end
	len = _arr:getSize()
	local spacingH = 180
	local w = spacingH * len
	w = - w / 2 + spacingH / 2;
	for i = 1, len do
		if _arr[i] == 11 then
			if self.giveUpIcon == nil then
				self.giveUpIcon = UICreate.createUIAtlasImage(self.maskObj, "fight_atlas_1", "xui_zd_button_005_n", 0, 0, 0, 0)
			end
			self.giveUpIcon:setEnable(true)
			self.giveUpIcon:setLocation(((i - 1) % len) * spacingH + w, 97, 0)
			self.giveUpIcon.name = _arr[i]
			self.giveUpIcon:addClickFuntion(self, self.onButtonClick)
		elseif _arr[i] == 12 then
			if self.replayIcon == nil then
				self.replayIcon = UICreate.createUIAtlasImage(self.maskObj, "fight_atlas_1", "xui_zd_button_004_n", 0, 0, 0, 0)
			end
			self.replayIcon:setEnable(true)
			self.replayIcon:setLocation(((i - 1) % len) * spacingH + w, 97, 0)
			self.replayIcon.name = _arr[i]
			self.replayIcon:addClickFuntion(self, self.onButtonClick)
		elseif _arr[i] == 13 then
			if self.continueIcon == nil then
				self.continueIcon = UICreate.createUIAtlasImage(self.maskObj, "fight_atlas_1", "xui_zd_button_006_n", 0, 0, 0, 0)
			end
			self.continueIcon:setEnable(true)
			self.continueIcon:setLocation(((i - 1) % len) * spacingH + w, 97, 0)
			self.continueIcon.name = _arr[i]
			self.continueIcon:addClickFuntion(self, self.onButtonClick)
		end
    end
end

function Lua_FightMainWindow:onButtonClick(data)
	if type(data) == "userdata" then
		data = data.name;
	end
	data = tonumber(data);

	if data == 0 then -- 加速
		self:onSpeed();
	elseif data == 1 then -- 跳过
		self:onSkip();
	elseif data == 2 then -- BUFF
		self:onCheckBuff();
	elseif data == 3 then -- 暂停
		self:onPause();
	elseif data == 4 then -- 挂起
		self:onHang();
	elseif data == 6 then -- 分队信息
		self:onCheckQueue();
	elseif data == 11 then -- 放弃战斗
		self:onGiveUp();
	elseif data == 12 then -- 重新开始
		self:onReplay();
	elseif data == 13 then -- 继续
		self:onContinue();
	end
end

function Lua_FightMainWindow:onSpeedChange()
	if self.speedIcon then
		self.speedIcon:setAltas("fight_atlas_1", "xui_zd_button_01"..(self._recordVo.showSpeed + 3).."_n")
	end
	if self.bossHurtPanel ~= nil then
		self.bossHurtPanel:setSpeedRate(self._recordVo.speedRate);
	end
end

-- 速度
function Lua_FightMainWindow:onSpeed()
	local idx = self._recordVo.speedIdx;
	local vipVo = DataCenter.vipData.curVipLevelVo;
	if vipVo ~= nil and vipVo.fightPlaySpeed ~= nil then
		if idx >= #vipVo.fightPlaySpeed then
			idx = 1;
		else
			idx = idx + 1;
		end
	end

	local templateCfg = self._recordVo.templateConfig;
	if idx > 1 and self._recordVo.isReplay ~= true and templateCfg ~= nil and templateCfg.speedCond ~= nil and #templateCfg.speedCond >= idx - 1 then
		if DataCenter.funcOpenData:isOpened(templateCfg.speedCond[idx - 1], true) == false then
			return;
		end
	end

	self._recordVo.speedIdx = idx;
	if self.speedTips then
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOperate("fight_speed_tips", 1)
		
		self.speedTips:dispose()
		self.speedTips = nil

		self.speedEff:dispose();
		self.speedEff = nil;
	end
end

-- 跳过
function Lua_FightMainWindow:onSkip()
	if not self:checkCanSkip() or self.isPressSkip == true then
		return;
	end
	self.isPressSkip = true

	local player
	local arr = DataCenter.fightData:getTeamArrById(self._recordVo.teamId)
	if arr then
		local vo
		for i = 1, arr:getSize() do
			vo = DataCenter.fightData:getRecordVoById(arr[i])
			if vo then
				vo:checkResult()
			end

			player = DataCenter.fightData:getFightPlayerById(arr[i])
			if player and player.isPlayEnd ~= true then
				player:playEnd(true)
			end
		end
	else
		self._recordVo:checkResult()
		player = DataCenter.fightData:getFightPlayerById(self._recordId)
		player:playEnd(true)
	end
end

function Lua_FightMainWindow:checkCanSkip()
	if self._recordVo ~= nil and self._recordVo.isReplay ~= true then
		if self._recordVo.templateId == Lua_FightDefine.TEMPLATE_ID_ARENA then
			local limitTimes = DataCenter.arenaUtil:getConstConfig("skip_fight_times", 1);
			if DataCenter.arenaData.fight_times < limitTimes then
				OperateAlert.show(LanUtil.formateStr(303024, tostring(limitTimes)));
				return false;
			end
		elseif self._recordVo.templateId == Lua_FightDefine.TEMPLATE_ID_PEAKDUEL then
			if not DataCenter.warOrderData:advActiveState(Lua_WarOrderData.PeakDuel, 1) then
				OperateAlert.showLangValue(202936);
				return false;
			end
		elseif self._recordVo.templateId == Lua_FightDefine.TEMPLATE_ID_STARTRIAL then
			if not DataCenter.starTrialUitl:getStateByStageId(self._recordVo.stageId) then
				OperateAlert.showLangValue(201630);
				return false;
			end
		elseif self._recordVo.templateId == Lua_FightDefine.TEMPLATE_ID_COPY_SINGLE then
			local data = DataCenter.equipCopyUtil:getSingleCapyVoById(self._recordVo.stageId);
			if data then
				local camp = data.camp;
				local diff = data.difficulty;
				local bSkip = DataCenter.equipCopyData:bSkipFightByDifficulty(camp,diff);
				if not bSkip then
					OperateAlert.show(LanUtil.formateStr(420105, DataCenter.equipCopyUtil.skip_fight_score));
					return false;
				end
			else
				return false;
			end
		end

		if self._recordVo.isReplay ~= true then
			if not DataCenter.funcOpenData:isOpened(self._recordVo.templateConfig.skipCond, true) then
				return false;
			end
		end
	end
	return true;
end

-- 状态
function Lua_FightMainWindow:onCheckBuff()
	if self._recordVo.templateId == Lua_FightDefine.TEMPLATE_ID_INFINITYHALL_1 
		or self._recordVo.templateId == Lua_FightDefine.TEMPLATE_ID_INFINITYHALL_2 then
		Lua_WindowUtil.openWin("Lua_InfinityHallBuffWindow", Lua_WinParam.ACTION_OPEN);
	else
		Lua_WindowUtil.openWin("Lua_FightOverallBuffWindow", Lua_WinParam.ACTION_OPEN, self._recordId);
	end
end

-- 暂停
function Lua_FightMainWindow:onPause()
	self.maskObj:SetActive(true);
	DataCenter.fightData:controllFightPlay(self._recordId, false);
end

-- 切换到后台
function Lua_FightMainWindow:onHang()
	if self._recordVo.isReplay ~= true then
		if not DataCenter.funcOpenData:isOpened(self._recordVo.templateConfig.hangCond, true) then
			return;
		end
	end

	if self.isPressHang == nil then -- 防止多次点击挂起按钮
		self.isPressHang = true;
		if self._recordVo.templateId == DataCenter.mainLineData.curTemplateId then
			local vo = DataCenter.funcPathUtil:getFuncPathVo(1005)
			if not vo.isShowing then
				DataCenter.funcPathUtil:gotoFunction(1005, true, false)
			end
		end
		DataCenter.fightData:hideFightToBackStageByRecordId(self._recordId);
		DataCenter.fightData:showNextResult(); -- 切换到后台后，是否有结算界面需显示
		DataCenter.funcPathUtil:clearFightRecordFuncPath(self._recordId);

		if self.hangTips then
			Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOperate("fight_hang_tips", 1)
			self.hangTips:dispose()
			self.hangTips = nil

			self.hangEff:dispose();
			self.hangEff = nil;
		end
	end
end

-- 查看队列
function Lua_FightMainWindow:onCheckQueue()
	local player = DataCenter.fightData:getFightPlayerById(self._recordId);
	if player ~= nil then
		local data = {
			attackerTeamIdx = player.attackerTeamIdx, -- 攻方分队索引
			defenderTeamIdx = player.defenderTeamIdx, -- 守方分队索引
			attackerLineup = self._recordVo.attacker.lineup, -- 攻方阵容
			defenderLineup = self._recordVo.defender.lineup; -- 守方阵容
		};
		Lua_WindowUtil.openWin("Lua_FightQueueWindow", Lua_WinParam.ACTION_OPEN, data);
	end
end

function Lua_FightMainWindow:onBlackMaskClick(go)
	self.maskObj:SetActive(false);
	DataCenter.fightData:controllFightPlay(self._recordId, true);
end

-- 放弃
function Lua_FightMainWindow:onGiveUp()
	self.maskObj:SetActive(false);
	if self._recordVo.isIgnoreResult == false then
		Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightResult(self._recordId, 2, self.curRotation);
	end
	DataCenter.fightData:removeFightResult(self._recordId);
	DataCenter.fightData:removeFight(self._recordId);
end

-- 重播
function Lua_FightMainWindow:onReplay()
	self.maskObj:SetActive(false);
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightResult(self._recordId, 2, self.curRotation);

	DataCenter.fightData:removeFightResult(self._recordId);
	local msg = DataCenter.fightData:getSendFightMsg(self._recordVo.templateId);
	if msg then
		DataCenter.fightData.curPlayFightRecordId = 0
		DataCenter.fightData.removeFightId = self._recordId
		sendMsg(10102001, msg);
	else
		self:onSkillHurtUpdate(0)
		DataCenter.fightData:replayFight(self._recordId);
	end
end

-- 继续
function Lua_FightMainWindow:onContinue()
	self.maskObj:SetActive(false);
	DataCenter.fightData:controllFightPlay(self._recordId, true);
end

function Lua_FightMainWindow:createPanel()
	if self.templateId == Lua_FightDefine.TEMPLATE_ID_STARTRIAL then
		self:createStarPanel()
		local arr = DataCenter.starTrialUitl:getStageVo(self._recordVo.stageId).starCondArr;
		self.starPanel:setData(arr);
		self.starPanel:setShowHide(true)
		self.starPanel:setAutoHide(5)
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_CHAOSFOREST then -- BOSS伤害
		if self.bossHurtPanel == nil then
			self.bossHurtPanel = Lua_FightBossHurtPanel.new(self.showObject);
			self.bossHurtPanel:setRectAnchor(1);
		end
		self.bossHurtPanel:setData(self.templateId, self._recordVo.stageId, self._recordVo.speedRate);
		self.bossHurtPanel:setHurtValue(self._recordVo.bossHurt)
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_COPY_SINGLE then
		self:createGradePanel();
		self.gradePanel:setAutoHide(3);
	elseif self._recordVo.templateId == Lua_FightDefine.TEMPLATE_ID_COPY_MORE then
		self:createGradePanel()
		self:createTeamUpPanel();
		self.gradePanel:setAutoHide(3);
		self.teamUpPanel:setAutoHide(3)
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_KUNXU then -- 战斗分队
		self:createStarPanel()
		local arr = DataCenter.kunXuHolyLandData:getLevelInfoById(self._recordVo.stageId).starCondArr
		self.starPanel:setData(arr);
		if self.detachmentPanel == nil then
			self.detachmentPanel = Lua_FightDetachmentPanel.new(self.showObject)
		end
		self.detachmentPanel:setData(self._recordVo)
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_LEAGUEDUELBOSS then
		if self.bossHurtPanel == nil then
			self.bossHurtPanel = Lua_FightBossHurtPanel.new(self.showObject);
			self.bossHurtPanel:setRectAnchor(1);
			self.bossHurtPanel.boxIcon:setEnable(false);
		end
		self.bossHurtPanel:setData(self.templateId, self._recordVo.stageId, self._recordVo.speedRate);
		self.bossHurtPanel:setStageConfig({name = self._recordVo.defender.name, monster_id = self._recordVo.defender.id})
		self.bossHurtPanel:setHurtValue(self._recordVo.bossHurt);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_BOSSCHALLENGE then -- BOSS挑战伤害
		if self.bossHurtPanel == nil then
			self.bossHurtPanel = Lua_FightBossChallengeHurtPanel.new(self.showObject);
			self.bossHurtPanel:setRectAnchor(1);
		end
		self.bossHurtPanel:setData(self.templateId, self._recordVo.stageId, self._recordVo.speedRate);
		self.bossHurtPanel:setHurtValue(self._recordVo.bossHurt)
	end
end

-- 战斗星级
function Lua_FightMainWindow:createStarPanel()
	if self.starPanel == nil then
		self.starPanel = Lua_FightStarPanel.new(self.showObject);
		self.starPanel:setRectAnchor(1);
		self.starPanel:setLocation(-325, -240.5, 0)
	end
end

-- 战斗评级
function Lua_FightMainWindow:createGradePanel()
	self.roundObj:SetActive(false);
	if self.gradePanel == nil then
		self.gradePanel = Lua_FightGradePanel.new(self.showObject);
		self.gradePanel:setRectAnchor(1);
		self.gradePanel:setLocation(171, -314, 0);
	end
	self.gradePanel:setShowHide(true);
end

-- 战斗组队
function Lua_FightMainWindow:createTeamUpPanel()
	if self.teamUpPanel == nil then
		self.teamUpPanel = Lua_FightTeamUpPanel.new(self.showObject)
		self.teamUpPanel:setRectAnchor(1);
		self.teamUpPanel:setLocation(0, -260, 0);
	end
	self.teamUpPanel:setShowHide(true);
end

function Lua_FightMainWindow:onUpdateCheck(recordId)
	if recordId == self._recordId then
		if self.starPanel then
			self.starPanel:updateData()
		end
	end
	if self.gradePanel then
		self.gradePanel:updateData()
	end
	if self.teamUpPanel then
		self.teamUpPanel:updateHp()
	end
	if self.detachmentPanel then
		self.detachmentPanel:setData(self._recordVo)
	end
end

function Lua_FightMainWindow:clearPanel()
	if self.bossHurtPanel then
		self.bossHurtPanel:dispose()
		self.bossHurtPanel = nil
	end
	if self.starPanel then
		self.starPanel:dispose()
		self.starPanel = nil
	end
	if self.gradePanel then
		self.gradePanel:dispose()
		self.gradePanel = nil
	end
	if self.teamUpPanel then
		self.teamUpPanel:dispose()
		self.teamUpPanel = nil
	end
	if self.detachmentPanel then
		self.detachmentPanel:dispose()
		self.detachmentPanel = nil
	end
end

function Lua_FightMainWindow:createSpeedTips(posY)
	local templateConfig = self._recordVo.templateConfig
	if templateConfig.speedCond and #templateConfig.speedCond > 0 then
		local bOpened = DataCenter.funcOpenData:isOpened(templateConfig.speedCond[1])
		local value = DataCenter.roleData:getOperationRecord("fight_speed_tips")
		if bOpened and value ~= 1 then
			if self.speedTips == nil then
				self.speedTips = UICreate.createUIEffect(self.showObject, "/effects/uiEffects/ui_zx_qp", "ui_zx_qp", 0, 0)
				self.speedTips.anchorValue = 7
				self.speedTips:setScale(-1, 1, 1)
				self.speedTips:setLocation(175, posY + 30, 0)

				self.speedEff = UICreate.createUIEffect(self.showObject, "/effects/uiEffects/ui_zx_zdan", "ui_zx_zdan", 0, 0)
				self.speedEff.anchorValue = 7;
				self.speedEff:setLocation(302, posY, 0);
			end
			self.speedTips:setEnable(true)
		else
			if self.speedTips then
				self.speedTips:setEnable(false)
			end
		end
	else
		if self.speedTips then
			self.speedTips:setEnable(false)
		end
	end
end

function Lua_FightMainWindow:createHangTips(posY)
	local bOpened = DataCenter.funcOpenData:isOpened(self._recordVo.templateConfig.hangCond)
	local value = DataCenter.roleData:getOperationRecord("fight_hang_tips")
	if bOpened and value ~= 1 then
		if self.hangTips == nil then
			self.hangTips = UICreate.createUIEffect(self.showObject, "/effects/uiEffects/ui_zx_qp", "ui_zx_qp", 0, 0)
			self.hangTips:setScale(-1, 1, 1)
			self.hangTips.anchorValue = 7
			self.hangTips:setLocation(175, posY + 30, 0)

			self.hangEff = UICreate.createUIEffect(self.showObject, "/effects/uiEffects/ui_zx_zdan", "ui_zx_zdan", 0, 0)
			self.hangEff.anchorValue = 7;
			self.hangEff:setLocation(299, posY + 7, 0);
		end
		self.hangTips:setEnable(true)
	else
		if self.hangTips then
			self.hangTips:setEnable(false)
		end
	end
end

-- 引导同步
function Lua_FightMainWindow:updateGuide(guideId, info)
	if info == nil then
		return;
	end
	
end

function Lua_FightMainWindow:onServerPlotUpdate(eid)
	if self.fightPlotPanel ~= nil then
		self.fightPlotPanel:updateServerPlot(eid);
	end
end

-- 战斗剧情
function Lua_FightMainWindow:updateFightPlot(plotId)
	if plotId > 0 then
		local cfg = getConfig("tb_fight_plot", plotId);
		if cfg ~= nil and cfg.event_list ~= nil and #cfg.event_list > 0 then
			if self.fightPlotPanel == nil then
				self.fightPlotPanel = Lua_FightPlotPanel.new(self.content);
				-- self.fightPlotPanel:setRectAnchor(9);
			end
			self.fightPlotPanel:playPlot(self._recordId, plotId, cfg);
			return;
		end
	end

	if self.fightPlotPanel ~= nil then
		self.fightPlotPanel:dispose();
		self.fightPlotPanel = nil;
	end
end

function Lua_FightMainWindow:onUpdateBossInfo(data)
	if data == nil or tonumber(tostring(data.fightRecordId)) ~= self._recordId then
		return
	end

	if self.bossInfoPanel == nil then
		self.bossInfoPanel = Lua_FightBossInfoPanel.new(self.showObject)
		self.bossInfoPanel:setRectAnchor(1)
		self.bossInfoPanel:setLocation(0, -193, 0)
	end
	self.bossInfoPanel:setEnable(true)
	self.bossInfoPanel:setData(data)
end