-- 战斗评级
Lua_FightGradePanel = class("Lua_FightGradePanel", Lua_DisplayObject);
function Lua_FightGradePanel:ctor(p)
	self:superCall("ctor", p, "FightGradePanel_skin");
end

function Lua_FightGradePanel:buildShowItem()
	self:superCall("buildShowItem");
	self.showDes.text = LanUtil.getValue(420110);
	self.gradeBg:addClickFuntion(self, self.onGradeBgClick);
end

function Lua_FightGradePanel:setAutoHide(value)
	value = value or 0
	Lua_CommonUtil.delayCall(value, self, self.onAutoHide)
end

function Lua_FightGradePanel:setShowHide(bool)
	self.showObj:SetActive(bool);
end

function Lua_FightGradePanel:onAutoHide()
	self:setShowHide(false);
	Lua_CommonUtil.removeTimer(self, self.onAutoHide)
end

function Lua_FightGradePanel:onGradeBgClick()
	self:setShowHide(true);
	self:setAutoHide(3);
end

function Lua_FightGradePanel:setData(recordId, teamId)
	self.teamId = teamId;
	if self.recordId ~= recordId then
		self:updateData(recordId);
	end
	self.recordId = recordId;
end

function Lua_FightGradePanel:updateData(recordId)
	local player;
	local round = 0;
	if self.teamId == nil or self.teamId <= 0 then
		recordId = recordId == nil and self.recordId or recordId;
		player = DataCenter.fightData:getFightPlayerById(recordId);
		if player ~= nil then
			round = player.curRound;
			self:updateGradeInfo(1, round);
		end
	else
		local arr = DataCenter.fightData:getTeamArrById(self.teamId);
		if arr ~= nil then
			for i = 1, arr:getSize() do
				player = DataCenter.fightData:getFightPlayerById(arr[i]);
				if player ~= nil then
					round = round + player.curRound;
				end
			end
			self:updateGradeInfo(2, round);
		end
	end
end

-- 评分
function Lua_FightGradePanel:updateGradeInfo(val, round)
	if self.round == round then
		return;
	end
	self.round = round; -- round：1~15
	local arr;
	if val == 1 then
		arr = DataCenter.equipCopyUtil.singleGradeInfo;
	else
		arr = DataCenter.equipCopyUtil.moreGradeInfo;
	end

	local index = 0;
	local grade; -- ["B","A","S","SS","SSS"]
	for i = 1, arr:getSize() do
		if round <= arr[i].num then
			grade = arr[i].grade;
			index = i;
		end
	end

	local show_grade = DataCenter.equipCopyUtil:getCopyScoreByGrade(grade - 1);
	local str = LanUtil.formateStr(420108,arr[index].num-round+1, show_grade);
	if show_grade == "" then
		str = LanUtil.getValue(420109);
	end

	self.showTips.text = str;
	self:updateShowGrade(grade);
end

function Lua_FightGradePanel:updateShowGrade(grade)
	if self.grade == grade then
		return;
	end
	self.grade = grade;

	self.showIcon:setAltas("equipcopy_atlas_2","xui_jmd_label_"..6-grade);
	self.showIcon:resetSize();
	self:onGradeBgClick();
end

function Lua_FightGradePanel:dispose()
	Lua_CommonUtil.removeTimer(self, self.onAutoHide)
	self:superCall("dispose");
end