--战斗队列
Lua_FightQueueWindow = class("Lua_FightQueueWindow", Lua_Window);
function Lua_FightQueueWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_FightQueueWindow";
	self.skinName = "FightQueueWindow_skin";
	self.showBlackMask = true;
end

function Lua_FightQueueWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.leftLineUpPanel = Lua_HeroGridViewPanel.new(self.content);
	self.leftLineUpPanel:setLocation(-170, 50, 0);
	self.leftLineUpPanel:setGridCell(73, 73);

	self.rightLineUpPanel = Lua_HeroGridViewPanel.new(self.content);
	self.rightLineUpPanel:setLocation(-170, 50, 0);
	self.rightLineUpPanel:setGridCell(73, 73);

	self.tabInfo = Array();
    self.tabInfo:add({textAtlas = "hero_title", textNormalSprite = "fonts_003", tagType = 1});
    self.tabInfo:add({textAtlas = "hero_title", textNormalSprite = "fonts_004", tagType =2});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setLocation(0, -490, 0);
	self.btnList:setButtonItem(184, 62);
	self.btnList:setClickCallBack(self, self.onTabBtnClick);
	self.btnList:setData(self.tabInfo);
end

function Lua_FightQueueWindow:dispose()
	self.tabInfo = nil;
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end

	if self.leftLineUpPanel ~= nil then
		self.leftLineUpPanel:dispose();
		self.leftLineUpPanel = nil;
	end

	if self.rightLineUpPanel ~= nil then
		self.rightLineUpPanel:dispose();
		self.rightLineUpPanel = nil;
	end

	self:superCall("dispose");
end


function Lua_FightQueueWindow:showWin(param)
	self:superCall("showWin", param);
	-- param.attackerTeamIdx; -- 攻方分队索引
	-- param.defenderTeamIdx; -- 守方分队索引
	-- param.attackerLineup; -- 攻方阵容
	-- param.defenderLineup; -- 守方阵容
	self.btnList:setSelected(1);
end

function Lua_FightQueueWindow:onTabBtnClick(val)
	if self.selectTabIndex == val then
		return;
	end
	self.selectTabIndex = val;
	self.tagType = self.tabInfo[val].tagType;
	self:showLineUpInfo();
end

function Lua_FightQueueWindow:showLineUpInfo()
	if self.selectTabIndex == val then
		return;
	end
	local list;
	local group_index;--当前出战的分队索引
	if self.tagType == 1 then--进攻方
		list = self.showData.attackerLineup;
		group_index = self.showData.attackerTeamIdx;
	elseif self.tagType == 2 then--防守方	
		list = self.showData.defenderLineup;
		group_index = self.showData.defenderTeamIdx;
	end

	self.leftLineUpPanel:setDataByProto(list[1].hero_list);
	self.rightLineUpPanel:setDataByProto(list[2].hero_list);

	self.left_force.text = list[1].force;
	self.right_force.text = list[2].force;
	-- self.left_icon:setAltas();--站位图标
	-- self.right_icon:setAltas();

	local left_des = "";
	local right_des = "";
	if group_index == 1 then
		left_des = "正在出战";
		right_des ="等待出战";
	elseif group_index == 2 then
		left_des = "已被击败";
		right_des ="正在出战";
	end
	self.left_state.text = left_des;
	self.right_state.text = right_des;
end