-- 公会对抗 抢夺失败界面
checkRequire("Lua_FightResultBaseWindow");
Lua_AllianceDuelFailWindow = class("Lua_AllianceDuelFailWindow", Lua_FightResultBaseWindow);
function Lua_AllianceDuelFailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_AllianceDuelFailWindow";
	self.skinName = "AllianceDuelFailWindow_skin";
    self.winBgPath = "/images/fight/xui_zd_bg_2.jpg";
    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
    self:addPreLoadRes("/effects/uiEffects/ui_ty_qdsb_01", Lua_LoadFileType.UNITY3D);
    self.openSound = "fight_lose_01";

	self.bIsWin = nil;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_AllianceDuelFailWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.uiEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ty_qdsb_01", "ui_ty_qdsb_01", 0, 205)

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setLocation(-145, -135, 0);

	self.otherAvatarItem = Lua_AvatarItem.new(self.content);
	self.otherAvatarItem:setLocation(142, -135, 0);

	self.cancelBtn:addClickFuntion(self, self.onCancelBtnClick);
	self.sureBtn:addClickFuntion(self, self.hide);
end

function Lua_AllianceDuelFailWindow:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	if self.otherAvatarItem ~= nil then
		self.otherAvatarItem:dispose();
		self.otherAvatarItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDuelFailWindow:showWin(param)
	self:superCall("showWin", param);

	local templateConfig = Lua_FightTemplateConfigData.getConfigData(param.template_id);
	self.nameText.text = templateConfig.title;

	local roleInfo = param.league_combat_att_info;
	self.avatarItem:setRoleDressUp(roleInfo.dress_info, false, false, 0.7);
	self.avatarItem:setAvatarBg("common_altas_3", "xui_common_widget_019", 0.8);
	self.myNameTxt.text = roleInfo.name;

	roleInfo = param.league_combat_def_info;
	self.otherAvatarItem:setRoleDressUp(roleInfo.dress_info, false, false, 0.7);
	self.otherAvatarItem:setAvatarBg("common_altas_3", "xui_common_widget_019", 0.8);
	self.otherNameTxt.text = roleInfo.name;

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteInfo();
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteRank(2);
end

function Lua_AllianceDuelFailWindow:updateFuncIcons()
	local configData = Lua_FightTemplateConfigData.getConfigData(self.templateId);
	local list = configData.failOpenIcons;
	if list == nil or #list <= 0 then
		self:removeFuncIcons();
	else
		if self.iconsList == nil then
			self.iconsList = Array();
		end
		local len = self.iconsList:getSize();
		local num = #list - len;

		while (num > 0) do
			item = Lua_IconSkipItem.new(self.content);
			self.iconsList:add(item);
			num = num - 1;
		end

		while (num < 0) do
			item = self.iconsList:remove(1);
			item:dispose();
			num = num + 1;
		end

		len = self.iconsList:getSize();
		local space = 140;
		local w;
		local posX;
		local posY;
		for i = 1, len do
			item = self.iconsList[i];
			item:setClick(self, self.onIconSkip);
			item:setData(list[i]);

			w = -(space * len) / 2 + space / 2;
			posX = ((i - 1) % len) * space + w;
			posY = -30 + Mathf.Floor((i - 1) / len) * space - 1;
			item:setLocation(posX, posY, 0);
		end
	end
end

function Lua_AllianceDuelFailWindow:onCancelBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1111, true);
end