-- 通用战斗失败窗口
checkRequire("Lua_FightResultBaseWindow");
Lua_FightFailResultWindow = class("Lua_FightFailResultWindow", Lua_FightResultBaseWindow)
function Lua_FightFailResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FightFailResultWindow";
	self.skinName = "FightFailResultWindow_skin";
    self.winBgPath = "/images/fight/xui_zd_bg_2.jpg";
    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
    self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sb_01", Lua_LoadFileType.UNITY3D);
    self.openSound = "fight_lose_01";

	self.bIsWin = false;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_FightFailResultWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.btnBack:addClickFuntion(self, self.onBackClick);
	self.btnSure:addClickFuntion(self, self.hide);
end

function Lua_FightFailResultWindow:hide()
	if self.templateId == DataCenter.mainLineData.curTemplateId then -- 主线冒险
		local iconId = DataCenter.mainMenuData.selectMainIconId;
		local vo = DataCenter.funcPathUtil:getFuncPathVo(1005)
		if iconId == Lua_MenuViewDefine.ICON_MAINLINE and not vo.isShowing then
			DataCenter.funcPathUtil:gotoFunction(1005, true, false)
		end
	end
	self:superCall("hide");
end

function Lua_FightFailResultWindow:showWin(param)
	self:superCall("showWin", param);

	local templateConfig = Lua_FightTemplateConfigData.getConfigData(param.template_id);
	self.nameText.text = templateConfig.title;
	self:updateFuncIcons("showObject_2");
end

function Lua_FightFailResultWindow:onBackClick()
	if self.templateId == DataCenter.mainLineData.curTemplateId then -- 主线冒险
		DataCenter.funcPathUtil:gotoFunction(1005, true);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_EXPEDITION then -- 边境远征
		DataCenter.funcPathUtil:gotoFunction(1016, true);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_LEAGUEBOSS then -- 公会BOSS
		DataCenter.funcPathUtil:gotoFunction(1062, true);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_COPY_SINGLE then -- 魔灵岛
		DataCenter.funcPathUtil:gotoFunction(1037, true);
	else
		DataCenter.funcPathUtil:gotoFunction(1001, true);
	end
end