-- 魔神试炼胜利面板
checkRequire("Lua_FightResultBaseWindow");
Lua_MonsterTrialFightWinResultWindow = class("Lua_MonsterTrialFightWinResultWindow", Lua_FightResultBaseWindow);
function Lua_MonsterTrialFightWinResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MonsterTrialFightWinResultWindow";
	self.skinName = "MonsterTrialFightResultWindow_skin";
	self.winBgPath = "/images/fight/xui_zd_bg_1.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sl_01", Lua_LoadFileType.UNITY3D);
	self.openSound = "fight_win_01";
	
	self.bIsWin = true;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_MonsterTrialFightWinResultWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.failObj:SetActive(false);
	self.sureBtn:setStyle(4);
	self.sureBtn:addClickFuntion(self, self.hide);
end

function Lua_MonsterTrialFightWinResultWindow:showWin(param)
	self:superCall("showWin", param);
	self:updateShowInfo();
	self:updateRewards(param.item_list);
end

function Lua_MonsterTrialFightWinResultWindow:updateShowInfo()
	self.integralTxt.text = self.showData.arena_self_info.score;
end

function Lua_MonsterTrialFightWinResultWindow:updateRewards(itemList)
	if itemList == nil or #itemList <= 0 then
		self:clearRewardList();
		return;
	end

	local tab = DataCenter.packData:getRewardDic(itemList);
	local arr = DataCenter.packData:getRewardList(tab);
	if self.rewardList == nil then
		local len = arr:getSize();
		if len > 4 then
			self.rewardList = Lua_DragList.new(self.content, 540, 152, Lua_AxisDefine.Vertical);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 112, 152, 4);
		else
			self.rewardList = Lua_DragList.new(self.content, len * 135, 152, Lua_AxisDefine.Horizontal);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 112, 152, 1);
		end
		self.rewardList:setCellSpacing(23, 0);
		self.rewardList:setLocation(10, -115, 0);
	end
	self.rewardList:setArrayData(arr);
	self.rewardList.canDrag = not self.rewardList.isTheEnd;
end

function Lua_MonsterTrialFightWinResultWindow:clearRewardList()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
end

function Lua_MonsterTrialFightWinResultWindow:dispose()
	self:clearRewardList();
	Lua_ProxyManager.getProxy("Lua_RankProxy"):sGetRankInfo(Lua_RankData.MONSTER_TYPE); -- 排行榜信息
	
	self:superCall("dispose");
end